#%define BuildRoot /tmp/%{name}-%{version}
%define __spec_install_post %{nil}

Summary: A web-based user account administration interface
Name: usermin
Version: 1.260
Release: 1.1ml
Provides: %{name}-%{version}
Requires: jcode.pl
AutoReq: 0
Prereq: /bin/sh /usr/bin/perl sh-utils perl-Net-SSLeay
Copyright: Freeware
Group: System/Tools
Source: http://www.webmin.com/download/%{name}-%{version}.tar.gz

Source100: usermin-miracle-at-ja_JP.euc
Source105: usermin-miracle-plan-ja_JP.euc
Source107: usermin-miracle-miracle.wbt.gz

Patch100: usermin-1.260-ml21-os_list.txt.patch
Patch101: usermin-miracle-at-module.info.patch
Patch102: usermin-1.080-cron-module.info.patch
#Patch103: usermin-1.080-fetchmail-module.info.patch
Patch104: usermin-1.260-mailbox-module.info.patch
Patch105: usermin-1.080-plan-module.info.patch
Patch106: usermin-1.260-quota-module.info.patch
Patch107: usermin-1.080-ssh-module.info.patch
Patch108: usermin-miracle-setup.sh.patch
#Patch109: usermin-1.080-telnet_port.patch

Patch200: usermin-1.260-ml21-spam.patch
Patch201: usermin-1.090-ml21-file.patch
Patch202: webmin-1.320-CVE-2007-3156.patch

BuildRoot: /tmp/%{name}-%{version}
BuildArchitectures: noarch
%description
A web-based user account administration interface for Unix systems.

After installation, enter the URL https://localhost:20000/ into your
browser and login as any user on your system.

%prep
%setup -q -a 107

%patch100 -p1
%patch101 -p1
%patch102 -p1
#%patch103 -p1
%patch104 -p1
%patch105 -p1
%patch106 -p1
%patch107 -p1
%patch108 -p1
#%patch109 -p1

%patch200 -p1
%patch201 -p1
%patch202 -p0

%build
(find . -name '*.cgi' ; find . -name '*.pl') | perl perlpath.pl /usr/bin/perl -
rm -f mount/freebsd-mounts-*
rm -f mount/openbsd-mounts-*
#chmod -R og-rxw .

%install
mkdir -p %{buildroot}/usr/libexec/usermin
mkdir -p %{buildroot}/etc/sysconfig/daemons
mkdir -p %{buildroot}/etc/rc.d/init.d
mkdir -p %{buildroot}/etc/pam.d
cp -rp * %{buildroot}/usr/libexec/usermin
cp usermin-daemon %{buildroot}/etc/sysconfig/daemons/usermin
cp usermin-init %{buildroot}/etc/rc.d/init.d/usermin
cp usermin-pam %{buildroot}/etc/pam.d/usermin
#ln -s /etc/rc.d/init.d/usermin %{buildroot}/etc/rc.d/rc2.d/S99usermin
#ln -s /etc/rc.d/init.d/usermin %{buildroot}/etc/rc.d/rc3.d/S99usermin
#ln -s /etc/rc.d/init.d/usermin %{buildroot}/etc/rc.d/rc5.d/S99usermin
#ln -s /etc/rc.d/init.d/usermin %{buildroot}/etc/rc.d/rc2.d/K10usermin
#ln -s /etc/rc.d/init.d/usermin %{buildroot}/etc/rc.d/rc3.d/K10usermin
#ln -s /etc/rc.d/init.d/usermin %{buildroot}/etc/rc.d/rc5.d/K10usermin
echo rpm >%{buildroot}/usr/libexec/usermin/install-type

#Add ja_JP.euc files
install -m 644 %{SOURCE100} %{buildroot}/usr/libexec/usermin/at/lang/ja_JP.euc
install -m 644 %{SOURCE105} %{buildroot}/usr/libexec/usermin/plan/lang/ja_JP.euc

%clean
#%{rmDESTDIR}
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
/usr/libexec/usermin
/etc/sysconfig/daemons/usermin
/etc/rc.d/init.d/usermin
#/etc/rc.d/rc2.d/S99usermin
#/etc/rc.d/rc3.d/S99usermin
#/etc/rc.d/rc5.d/S99usermin
#/etc/rc.d/rc2.d/K10usermin
#/etc/rc.d/rc3.d/K10usermin
#/etc/rc.d/rc5.d/K10usermin
/etc/pam.d/usermin

%pre
perl <<EOD;
# maketemp.pl
# Create the /tmp/.webmin directory if needed

\$tmp_dir = \$ENV{'tempdir'} || "/tmp/.webmin";

while(\$tries++ < 10) {
	local @st = lstat(\$tmp_dir);
	exit(0) if (\$st[4] == \$< && (-d _) && (\$st[2] & 0777) == 0755);
	if (@st) {
		unlink(\$tmp_dir) || rmdir(\$tmp_dir) ||
			system("/bin/rm -rf ".quotemeta(\$tmp_dir));
		}
	mkdir(\$tmp_dir, 0755) || next;
	chown(\$<, \$(, \$tmp_dir);
	chmod(0755, \$tmp_dir);
	}
exit(1);


EOD
if [ "$?" != "0" ]; then
	echo "Failed to create or check temp files directory /tmp/.webmin"
	exit 1
fi
perl >/tmp/.webmin/$$.check <<EOD;
if (-r "/etc/.issue") {
	\$etc_issue = \`cat /etc/.issue\`;
	}
elsif (-r "/etc/issue") {
	\$etc_issue = \`cat /etc/issue\`;
	}
if (\`cat /etc/miraclelinux-release 2>&1\` =~ /2\\.0/) {
	print "oscheck='Miracle Linux 2.0'\\n";
	}
if (\`cat /etc/miraclelinux-release 2>&1\` =~ /2\\.1/) {
	print "oscheck='Miracle Linux 2.1'\\n";
	}
if (\$etc_issue =~ /red\\s*hat.*\\s2\\.1AS/i || \`cat /etc/redhat-release 2>&1\` =~ /2\\.1AS/) {
	print "oscheck='Redhat Linux Advanced Server 2.1AS'\\n";
	}
if (\`cat /etc/miraclelinux-release 2>&1\` =~ /2\\.0/) {
        print "oscheck='Miracle Linux 2.0'\\n";
        }
if (\`cat /etc/miraclelinux-release 2>&1\` =~ /2\\.1/) {
        print "oscheck='Miracle Linux 2.1'\\n";
        }
if (\`cat /etc/redhat-release 2>/dev/null\` =~ /(3\\.0AS)|(2\\.9\\.5AS)|(AS\\s+release\\s+3)/i) {
	print "oscheck='Miracle Linux 3.0'\\n";
	}

EOD
. /tmp/.webmin/$$.check
rm -f /tmp/.webmin/$$.check
if [ ! -r /etc/usermin/config ]; then
	if [ "$oscheck" = "" ]; then
		echo Unable to identify operating system
		exit 2
	fi
	echo Operating system is $oscheck
	if [ "$USERMIN_PORT" != "" ]; then
		port=$USERMIN_PORT
	else
		port=20000
	fi
	perl -e 'use Socket; socket(FOO, PF_INET, SOCK_STREAM, getprotobyname("tcp")); setsockopt(FOO, SOL_SOCKET, SO_REUSEADDR, pack("l", 1)); bind(FOO, pack_sockaddr_in($ARGV[0], INADDR_ANY)) || exit(1); exit(0);' $port
	if [ "$?" != "0" ]; then
		echo Port $port is already in use
		exit 3
	fi
fi

%post
inetd=`grep "^inetd=" /etc/usermin/miniserv.conf 2>/dev/null | sed -e 's/inetd=//g'`
if [ -f "/var/usermin/miniserv.pid" ]; then
	pid=`cat /var/usermin/miniserv.pid`
	kill -0 $pid >/dev/null 2>&1
	if [ "$?" = "0" ]; then
		active=1
	else
		active=0
	fi
else
	active=0
fi
if [ "$1" != 1 ]; then
	# Upgrading the RPM, so stop the old usermin properly
	if [ "$inetd" = 0 ]; then
		/sbin/service usermin stop >/dev/null 2>&1
	fi
else
	/sbin/chkconfig --add usermin
	/sbin/chkconfig usermin off
fi

cd /usr/libexec/usermin
config_dir=/etc/usermin
var_dir=/var/usermin
perl=/usr/bin/perl
autoos=3
if [ "$USERMIN_PORT" != "" ]; then
	port=$USERMIN_PORT
else
	port=20000
fi
host=`hostname`
ssl=1
atboot=1
nochown=1
autothird=1
noperlpath=1
nouninstall=1
nostart=1
export config_dir var_dir perl autoos port ssl nochown autothird noperlpath nouninstall nostart allow host
/usr/libexec/usermin/setup.sh >/tmp/usermin-setup.out 2>&1
rm -f /var/lock/subsys/usermin
if [ "" != "1" -a "$active" = "1" ]; then
	/etc/init.d/usermin start >/dev/null 2>&1 </dev/null
fi
cat >/etc/usermin/uninstall.sh <<EOFF
#!/bin/sh
printf "Are you sure you want to uninstall Usermin? (y/n) : "
read answer
printf "\n"
if [ "\$answer" = "y" ]; then
	echo "Removing usermin RPM .."
	rpm -e --nodeps usermin
	echo "Done!"
fi
EOFF
chmod +x /etc/usermin/uninstall.sh
port=`grep "^port=" /etc/usermin/miniserv.conf | sed -e 's/port=//g'`
echo "Usermin install complete. You can login to https://localhost:$port/"
echo "as any user on your system after starting usermin service."

%preun
echo "Preuninstall : $1"
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/usermin /etc/usermin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of usermin
		# has taken it's place. Stop the server
		/etc/rc.d/init.d/usermin stop >/dev/null 2>&1
		/sbin/chkconfig --del usermin
	fi
fi

%postun
echo "Postuninstall : $1"
if [ "$1" = 0 ]; then
	grep root=/usr/libexec/usermin /etc/usermin/miniserv.conf >/dev/null 2>&1
	if [ "$?" = 0 ]; then
		# RPM is being removed, and no new version of usermin
		# has taken it's place. Delete the config files
		rm -rf /etc/usermin /var/usermin
	fi
fi

%changelog
* Thu Oct 15 2009 Ryoji Kamei <kamei@miraclelinux.com> 1.260-1.1ml
- fix CVE-2007-3156

* Thu Apr 12 2007 Ryoji Kamei <kamei@miraclelinux.com> 1.260-1ml
- 1.260 for security update

* Wed Oct 13 2004 MORIYAMA Masayuki <moriyama@miraclelinux.com> 1.090-1ml
- upgraded to 1.090 for a security fix

* Tue Sep 14 2004 Shiro Yamada <shiro@miraclelinux.com> 1.090-3AX
- start usermin daemon only if it was running before upgrading

* Tue Sep 14 2004 Shiro Yamada <shiro@miraclelinux.com> 1.090-2AX
- for some reason ssh client feature no longer works, so I have
  ported the code from 1.080

* Thu Sep  9 2004 Shiro Yamada <shiro@miraclelinux.com> 1.090-1AX
- upgraded to 1.090 for a potential command execution vulnerability

* Wed Jun 16 2004 Shiro Yamada <shiro@miraclelinux.com> 1.080-1AX
- upgraded to 1.080 for a security fix

* Tue May 18 2004 Shiro Yamada <shiro@miraclelinux.com> 1.070-2AX
- cleaning up post section
- only start usermin daemon when upgrading

* Thu Apr  8 2004 Shiro Yamada <shiro@miraclelinux.com> usermin-1.070-1AX
- upgrading the code base to 1.070

* Sat Jun 29 2002 Yuji Oishi <yoishi@miraclelinux.com>
- check os type by only /etc/miraclelinux-release, because /etc/issue and
  /etc/miraclelinux-release are different before rebooting after updating

* Tue Jun 25 2002 Yuji Oishi <yoishi@miraclelinux.com>
- change miracle/images/*.gif to new version.

* Thu Jun 20 2002 Yuji Oishi <yoishi@miraclelinux.com>
- add desc_ja_JP.euc in module.info files of (at, changepass, cron, cshrc,
  fetchmail, forward, gnupg, language, mailbox, plan, proc, quota, ssh, theme) 
- add "miracle" module for MIRACLE LINUX THEME
- change default lang to ja_JP.euc, default theme to miracle, and so on.
- delete making link in /etc/rc.d/rc*.d, execute chkconfig instead.

* Sat Jun 15 2002 Yuji Oishi <yoishi@miraclelinux.com>
- add Miracle Linux 2.0, 2.1 and RHAS 2.1 for os check in spec file and
  os_list.txt

* Sat Jun 8 2002 Yuji Oishi <yoishi@miraclelinux.com>
- add ja_JP.euc files for at, changepass, cshrc, forward, language, plan, theme.
- change ssl=0 to ssl=1.
- add "allow=localhost" to forbid remote access in spec file.
- change the description such as "http://localhost:20000" to "https://...." in
  spec file.
- change "Requires:" from "/bin/sh /usr/bin/perl" to "jcode.pl", also add
  "Prereq: /bin/sh /usr/bin/perl sh-utils perl-Net-SSLeay" in spec file.
- delete Vendor tag.
- save config files(config, miniserv.conf) as *.um_rpmsave when updating
  in spec file
- add miraclelinux-release checking line in spec file.
